/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  javax.servlet.ServletOutputStream
 *  javax.servlet.http.HttpServletResponse
 */
package com.deepexi.scd.calculate.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Objects;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;

public class ZipUtils {
    private static final String PATCH = "/";
    private static final int BUFFER = 2048;
    private static final String CHAR_SET = "UTF-8";

    public static void compress(List<ZipFile> files, ZipOutputStream zipOutputStream) throws Exception {
        ZipUtils.handleRepeatName(files);
        ZipUtils.compress(files, zipOutputStream, "");
    }

    private static void handleRepeatName(List<ZipFile> files) {
        if (Objects.isNull(files) || files.size() < 1) {
            return;
        }
        HashMap map = new HashMap(16);
        files.forEach(file -> {
            ZipUtils.handleRepeatName(file.getFiles());
            String name = file.getName();
            Integer count = (Integer)map.get(name);
            if (Objects.isNull(count)) {
                map.put(name, 1);
                return;
            }
            map.put(name, count + 1);
            int index = name.lastIndexOf(".");
            name = index < 0 ? name + "(" + count + ")" : name.substring(0, index) + "(" + count + ")" + name.substring(index);
            map.put(name, 1);
            file.setName(name);
        });
    }

    public static void compress(List<ZipFile> files, ZipOutputStream zipOutputStream, String basePath) throws Exception {
        if (Objects.isNull(files)) {
            return;
        }
        for (ZipFile file : files) {
            if (file.isDirectory()) {
                ZipUtils.compressDir(file, zipOutputStream, basePath);
                continue;
            }
            ZipUtils.compressFile(file, zipOutputStream, basePath);
        }
    }

    private static void compressDir(ZipFile file, ZipOutputStream zipOutputStream, String basePath) throws Exception {
        try {
            basePath = basePath + file.getName() + PATCH;
            List<ZipFile> files = file.getFiles();
            ZipEntry zipEntry = new ZipEntry(basePath);
            zipOutputStream.putNextEntry(zipEntry);
            zipOutputStream.closeEntry();
            ZipUtils.compress(files, zipOutputStream, basePath);
        }
        catch (Exception e) {
            throw new Exception(e.getMessage(), e);
        }
    }

    private static void compressFile(ZipFile file, ZipOutputStream zipOutputStream, String dir) throws Exception {
        try {
            ZipEntry zipEntry = new ZipEntry(dir + file.getName());
            zipOutputStream.putNextEntry(zipEntry);
            InputStream bis = file.getInputStream();
            int count = 0;
            byte[] data = new byte[2048];
            while ((count = bis.read(data, 0, 2048)) != -1) {
                zipOutputStream.write(data, 0, count);
            }
            bis.close();
            zipOutputStream.closeEntry();
        }
        catch (Exception e) {
            throw new Exception(e.getMessage(), e);
        }
    }

    public static void export(List<ZipFile> zipFiles, HttpServletResponse response, String exportName) throws Exception {
        response.reset();
        response.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode(exportName + ".zip", CHAR_SET));
        response.setContentType("application/octet-stream");
        response.setCharacterEncoding("utf-8");
        ServletOutputStream outputStream = response.getOutputStream();
        ZipOutputStream zipOutputStream = new ZipOutputStream((OutputStream)outputStream);
        ZipUtils.compress(zipFiles, zipOutputStream);
        zipOutputStream.flush();
        zipOutputStream.close();
    }

    public static void main(String[] args) throws Exception {
        ZipOutputStream zipOutputStream = new ZipOutputStream(new FileOutputStream(new File("/Users/zouhaitian/Downloads/a.zip")));
        ArrayList<ZipFile> files = new ArrayList<ZipFile>();
        ZipFile dir1 = new ZipFile();
        dir1.setDirectory(true);
        dir1.setName("核算单元1");
        dir1.setFiles(new ArrayList<ZipFile>());
        ZipFile dir2 = new ZipFile();
        dir2.setDirectory(true);
        dir2.setName("核算单元2");
        dir2.setFiles(new ArrayList<ZipFile>());
        ZipFile dir3 = new ZipFile();
        dir3.setDirectory(true);
        dir3.setName("核算单元1");
        dir3.setFiles(new ArrayList<ZipFile>());
        ZipFile dir4 = new ZipFile();
        dir4.setDirectory(true);
        dir4.setName("核算单元1");
        dir4.setFiles(new ArrayList<ZipFile>());
        FileInputStream image1 = new FileInputStream(new File("/Users/zouhaitian/Pictures/download/images的副本.jpg"));
        FileInputStream image2 = new FileInputStream(new File("/Users/zouhaitian/Pictures/download/images的副本.jpg"));
        ZipFile imageFile1 = new ZipFile();
        imageFile1.setName("images的副本.jpg");
        imageFile1.setDirectory(false);
        imageFile1.setInputStream(image1);
        ZipFile imageFile2 = new ZipFile();
        imageFile2.setName("images的副本.jpg");
        imageFile2.setDirectory(false);
        imageFile2.setInputStream(image2);
        dir2.getFiles().add(imageFile1);
        dir2.getFiles().add(imageFile2);
        dir1.getFiles().add(dir2);
        files.add(dir1);
        files.add(dir3);
        files.add(dir4);
        ZipUtils.compress(files, zipOutputStream);
        zipOutputStream.flush();
        zipOutputStream.close();
    }

    public static class ZipFile {
        private boolean directory;
        private String name;
        private InputStream inputStream;
        private List<ZipFile> files;

        public void setDirectory(boolean directory) {
            this.directory = directory;
        }

        public void setName(String name) {
            this.name = name;
        }

        public void setInputStream(InputStream inputStream) {
            this.inputStream = inputStream;
        }

        public void setFiles(List<ZipFile> files) {
            this.files = files;
        }

        public boolean isDirectory() {
            return Boolean.TRUE.equals(this.directory);
        }

        public List<ZipFile> getFiles() {
            return this.files;
        }

        public String getName() {
            return this.name;
        }

        public InputStream getInputStream() {
            return this.inputStream;
        }
    }
}

